<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.7.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <title>List Users</title>
</head>
<script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    var gID;
    const gBASE_URL = "http://203.171.20.210:8080/crud-api/users/";
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    $(document).ready(function () {
        onPageLoading();
        $("#btn-update").on("click",function(){
            onBtnUpdateClick();
        })
    });
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
        var vUrlString = window.location.href;
        var vUrl = new URL(vUrlString);
        gID = vUrl.searchParams.get("id");
        const vListUserPage = "listUser.html"
        if (gID == null) {
            alert("không có id của đơn hàng");
            window.location.href = vListContact;
        }
        console.log(gID);
        callApiAndLoadToFormById(gID);
    }
    function onBtnUpdateClick(){
        //khai báo đối tượng
        var vUserUpdateObj = {
            firstname:"",
            lastname:"",
            subject:"",
            country:"",
            customerType:"",
            registerStatus:""
        }
        //B1 Thu thập dữ liệu trên form đưa vào obj
        thuThapDuLieu(vUserUpdateObj);
        //B2 kiểm tra dữ liệu
        var vDuLieuHopLe = kiemTraDuLieu(vUserUpdateObj);
        if(vDuLieuHopLe){
            //B3 gọi api update user
            callApiUpdateUser(vUserUpdateObj,gID);
        }
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    function callApiAndLoadToFormById(paramUserId){
        $.ajax({
            url:"http://203.171.20.210:8080/crud-api/users/" + paramUserId,
            type:"GET",
            success: function (dataUserObj) {
                console.log(dataUserObj)
                loadDataToForm(dataUserObj);
            },
            error: function (paramError) {
                console.log(paramError.status);
            }
        })
    }
    function loadDataToForm(paramUserObj){
        $("#inp-firstname").val(paramUserObj.firstname);
        $("#inp-lastname").val(paramUserObj.lastname);
        $("#inp-subject").val(paramUserObj.subject);
        $("#sel-country").val(paramUserObj.country);
        $("#sel-customer-type").val(paramUserObj.customerType);
        $("#sel-register-status").val(paramUserObj.registerStatus);
    }
    function thuThapDuLieu(paramUserObj){
        paramUserObj.firstname = $("#inp-firstname").val();
        paramUserObj.lastname = $("#inp-lastname").val();
        paramUserObj.subject =  $("#inp-subject").val();
        paramUserObj.country = $("#sel-country").val();
        paramUserObj.customerType = $("#sel-customer-type").val();
        paramUserObj.registerStatus = $("#sel-register-status").val();
    }
    function kiemTraDuLieu(paramUserObj){
        if(paramUserObj.firstname == ""){
            alert("Chưa nhập firstname");
            return false;
        }
        if(paramUserObj.lastname == ""){
            alert("Chưa nhập lastname");
            return false;
        }
        if(paramUserObj.subject == ""){
            alert("Chưa nhập subject");
            return false;
        }
        if(paramUserObj.country == ""){
            alert("Chưa chọn country");
            return false;
        }
        if(paramUserObj.customerType == ""){
            alert("Chưa chọn customer type");
            return false;
        }
        if(paramUserObj.registerStatus == ""){
            alert("Chưa chọn register status");
            return false;
        }
        return true;
    }
    function callApiUpdateUser(paramUserObj,paramUserId){
        
        $.ajax({
            url:"http://203.171.20.210:8080/crud-api/users/"+ paramUserId,
            type:"PUT",
            contentType:"application/json",
            data:JSON.stringify(paramUserObj),
            success:function(paramRespon){
                alert("User ID: " + paramRespon.id + "Cập nhật thông tin thành công");
                window.location.href = "listUsers.html";
            },
            error:function(ajaxContext){
                console.log(ajaxContext);
            }
        })
    }
</script>

<body>
    <div class="container jumbotron">
        <p class="h3 text-center mt-5">CHI TIẾT USER</p>
        <div class="row form-group">
            <div class="col-2 text-right">
                <label for="">Firstname </label>
            </div>
            <div class="col-4">
                <input type="text" class="form-control" id="inp-firstname">
            </div>
        </div>
        <div class="row form-group">
            <div class="col-2 text-right">
                <label for="">Lastname </label>
            </div>
            <div class="col-4">
                <input type="text" class="form-control" id="inp-lastname">
            </div>
        </div>
        <div class="row form-group">
            <div class="col-2 text-right">
                <label for="">Subject</label>
            </div>
            <div class="col-4">
                <input type="text" class="form-control" id="inp-subject">
            </div>
        </div>
        <div class="row form-group">
            <div class="col-2 text-right">
                <label for="">Country</label>
            </div>
            <div class="col-4">
                <select name="" class="form-control" id="sel-country">
                    <option value="VN">Việt Nam</option>
                    <option value="USA">USA</option>
                    <option value="AUS">Australia</option>
                    <option value="CAN">Canada</option>
                </select>
            </div>
        </div>
        <div class="row form-group">
            <div class="col-2 text-right">
                <label for="">Customer Type</label>
            </div>
            <div class="col-4">
                <select name="" class="form-control" id="sel-customer-type">
                    <option value="Standard">Standard</option>
                    <option value="Gold">Gold</option>
                    <option value="Premium">Premium</option>
                </select>
            </div>
        </div>
        <div class="row form-group">
            <div class="col-2 text-right">
                <label for="">Register Status</label>
            </div>
            <div class="col-4">
                <select name="" class="form-control" id="sel-register-status">
                    <option value="New">New</option>
                    <option value="Accepted">Accepted</option>
                    <option value="Denied">Denied</option>
                </select>
            </div>
        </div>
        <div class="row form-group">
            <div class="col-3">
                <button class="btn btn-success form-control" id="btn-update">Update User</button>
            </div>
            <div class="col-3">
                <button class="btn btn-success form-control">Hủy bỏ</button>
            </div>
        </div>

    </div>
</body>

</html>